package com.zksy.visualization.controller.smartElectricController;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.zksy.common.core.domain.Result;
import com.zksy.visualization.config.IccConfigProperty;
import com.zksy.visualization.domain.request.AirConditionerControlRequest;
import com.zksy.visualization.domain.request.AirConditionerRequest;
import com.zksy.visualization.domain.response.AirConditionerControlResponse;
import com.zksy.visualization.domain.response.AirConditionerResponse;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import okhttp3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;

/**
 * @author Administrator
 * @version 1.0
 * @project dh-server-micro
 * @description 智慧用电-空调控制
 * @date 2024/12/12 16:58:15
 */
@RestController
@Api(tags = "智慧用电-空调控制", description = "智慧用电-空调控制")
@RequestMapping("/airConditioner")
@Slf4j
public class AirConditionerController {
    @Autowired
    private IccConfigProperty iccConfigProperty;
    @Autowired
    private OkHttpClient httpClient;
    @Autowired
    private RedisTemplate<String,String> redisTemplate;

    private static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");

    @ApiOperation(value = "根据条件查询空调信息")
    @PostMapping("/getAirConditionerInfo")
    public Result getAirConditionerInfo(AirConditionerRequest request){
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonParams = null;
        String authorization = redisTemplate
                .opsForValue()
                .get("Authorization:" + iccConfigProperty.getUsername());
        try {
            jsonParams = objectMapper.writeValueAsString(request);
        } catch (JsonProcessingException e) {
            log.error("JSON序列化失败: {}", e);
            return Result.error("请求失败");
        }
        // 创建请求体
        RequestBody body = RequestBody.create(jsonParams, JSON);
        // 构建请求
        Request requestHttp = new Request.Builder()
                .url("https://" + iccConfigProperty.getHost() + "/evo-apigw/evo-electricity/"+ iccConfigProperty.getVersion() +"/airConditioner/search")
                .addHeader("Authorization", authorization)
                .post(body)
                .build();
        // 发送请求
        try (Response response = httpClient.newCall(requestHttp).execute()) {
            if (!response.isSuccessful()) {
                return Result.error("请求失败");
            }
            ResponseBody responseBody = response.body();
            if (responseBody != null) {
                String responseString = responseBody.string();
                JsonNode rootNode = objectMapper.readTree(responseString);
                JsonNode success = rootNode.path("success");
                if(success.isBoolean() && success.asBoolean()) {
                    JsonNode dataNode = rootNode.path("data");
                    if (dataNode.isObject()) {
                        AirConditionerResponse intelligentPanelResponse = objectMapper.treeToValue(dataNode, AirConditionerResponse.class);
                        return Result.ok(intelligentPanelResponse);
                    } else {
                        return Result.ok(null);
                    }
                }else {
                    JsonNode errMsgNode = rootNode.path("errMsg");
                    String errMsg = errMsgNode.isTextual() ? errMsgNode.asText() : "未知错误";
                    return Result.error(errMsg);
                }
            }
        } catch (IOException e) {
            log.error("请求失败: {}", e);
        }
        return Result.error("请求失败");
    }

    @ApiOperation(value = "批量设置空调属性")
    @PostMapping("/controlAirConditioner")
    public Result controlAirConditioner(AirConditionerControlRequest request){
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonParams = null;
        String authorization = redisTemplate
                .opsForValue()
                .get("Authorization:" + iccConfigProperty.getUsername());
        try {
            jsonParams = objectMapper.writeValueAsString(request);
        } catch (JsonProcessingException e) {
            log.error("JSON序列化失败: {}", e);
            return Result.error("请求失败");
        }
        // 创建请求体
        RequestBody body = RequestBody.create(jsonParams, JSON);
        // 构建请求
        Request requestHttp = new Request.Builder()
                .url("https://" + iccConfigProperty.getHost() + "/evo-apigw/evo-electricity/"+ iccConfigProperty.getVersion() +"/airConditioner/controlMulti")
                .addHeader("Authorization", authorization)
                .post(body)
                .build();
        // 发送请求
        try (Response response = httpClient.newCall(requestHttp).execute()) {
            if (!response.isSuccessful()) {
                return Result.error("请求失败");
            }
            ResponseBody responseBody = response.body();
            if (responseBody != null) {
                    String responseString = responseBody.string();
                JsonNode rootNode = objectMapper.readTree(responseString);
                JsonNode success = rootNode.path("success");
                if(success.isBoolean() && success.asBoolean()) {
                    JsonNode dataNode = rootNode.path("data");
                    if (dataNode.isObject()) {
                        AirConditionerControlResponse intelligentPanelResponse = objectMapper.treeToValue(dataNode, AirConditionerControlResponse.class);
                        return Result.ok(intelligentPanelResponse);
                    } else {
                        return Result.ok(null);
                    }
                }else {
                    JsonNode errMsgNode = rootNode.path("errMsg");
                    String errMsg = errMsgNode.isTextual() ? errMsgNode.asText() : "未知错误";
                    return Result.error(errMsg);
                }
            }
        } catch (IOException e) {
            log.error("请求失败: {}", e);
        }
        return Result.error("请求失败");
    }
    /*public AirConditionerControlResponse getAirConditionerControl(AirConditionerControlRequest airConditionerControlRequest){
        OauthConfigUserPwdInfo config = oauthConfigUtil.getOauthConfig();
        AirConditionerControlResponse response=null;
        try {
            log.info("airConditioner,controlAirConditioner,request:{}", JSONUtil.toJsonStr(airConditionerControlRequest));
            response = HttpUtils.executeJson("/evo-apigw/evo-electricity/"+ iccConfigProperty.getVersion() +"/airConditioner/controlMulti", airConditionerControlRequest,null, Method.POST , config, AirConditionerControlResponse.class);
            log.info("airConditioner,controlAirConditioner,response:{}", JSONUtil.toJsonStr(response));
        } catch (ClientException e) {
            log.error(e.getErrMsg(), e);
        }
        if(!response.isSuccess()) {
            log.info("批量设置空调属性失败:{}",response.getErrMsg());
        }
        return response;
    }
    public AirConditionerResponse getAirConditioner(AirConditionerRequest airConditionerRequest){
        OauthConfigUserPwdInfo config = oauthConfigUtil.getOauthConfig();
        AirConditionerResponse response=null;
        try {
            log.info("airConditioner,getAirConditionerInfo,request:{}", JSONUtil.toJsonStr(airConditionerRequest));
            response = HttpUtils.executeJson("/evo-apigw/evo-electricity/"+ iccConfigProperty.getVersion() +"/airConditioner/search", airConditionerRequest,null, Method.POST , config, AirConditionerResponse.class);
            log.info("airConditioner,getAirConditionerInfo,response:{}", JSONUtil.toJsonStr(response));
        } catch (ClientException e) {
            log.error(e.getErrMsg(), e);
        }
        if(!response.isSuccess()) {
            log.info("根据条件查询空调信息失败:{}",response.getErrMsg());
        }
        return response;
    }
*/

}
